//普通模块
var path = require('path');
var fs = require('fs');
var util = require('util');
var url = require('url');
var glob = require('glob');
var mkdirp = require('mkdirp');
module.exports = function (options) {
  var options = util._extend({
    cwd: 'src/p',
    src: ['**/**.html', '!**/**.jst.html', '!**/**.xtpl.html'],
    handData: null,
    distPath: null,
    macthReg: /<!--\s*html\slist[^-]*-->/g
  }, options || {});
  if(!options.templatePath){
  	options.templatePath = path.join(__dirname,'lib/template.html');
  }
  content = fs.readFileSync(options.templatePath,'utf8');
  var content = getBodyContent({
  	content: content,
  	match: content.match(options.macthReg)
  });
  var distPath = options.distPath;
  if(distPath){
  	var dirname = path.dirname(distPath);
  	if(!fs.existsSync(dirname)){
  		mkdirp.sync(dirname);
  	}
  	fs.writeFileSync(distPath,content,'utf8')
  }else{
  	return content;
  }
  function getBodyContent(obj) {
    var arr = getMacthFile();
    var content = obj.content.replace(obj.match, getHtmlCode(arr));
    return content;
  }
  function getHtmlCode(arr) {
    var style = fs.readFileSync(path.join(__dirname, 'lib/style.css'), {encoding: 'utf8'});
    style = '<style>' + style + '</style>';
    var lis = [];
    if(typeof options.handData === 'function'){
    	arr = options.handData(arr);
    }
    arr.forEach(function (item) {
    	item = item || {};
    	var url = item.url || path.join(options.cwd, item);
    	var name = item.name || item;
       lis.push('<li><a href= "' + url + '" class="icon icon-html" title="' + name + '"><span class="name">' + name + '</span></a></li>');
    });
    return style + '<div class="directory"><div id="wrapper"><h1>/</h1><ul class="view-tiles" id="files">' + lis.join('') + '</ul></div></div>';
  }

  function getMacthFile() {
    var opts = options;
    var macth = [];
    var removeMacth = [];
    typeof opts.src === 'string' && (opts.src = [opts.src]);
    if (util.isArray(opts.src)) {
      opts.src.forEach(function (item) {
        if (item.indexOf('!') === 0) {
          removeMacth = concat(removeMacth, glob.sync(item.slice(1), opts));
        } else {
          macth = concat(macth, glob.sync(item, opts));
        }
      })
    }
    removeMacth.forEach(function (item) {
      var i = macth.indexOf(item);
      i !== -1 && (macth.splice(i, 1));
    });
    //去重
    function concat(arr1, arr2) {
      arr2.forEach(function (item) {
        var i = arr1.indexOf(item);
        i === -1 && arr1.push(item);
      });
      return arr1;
    }
    return macth;
  }

};